您的位置:首页 > 其它

【Codeforces Round 323 (Div 2)B】【贪心】Robot's Task 最少转弯次数拿走所有物品

2015-11-13 11:21 246 查看
B. Robot's Task

time limit per test
1 second

memory limit per test
256 megabytes

input
standard input

output
standard output

Robot Doc is located in the hall, with n computers
stand in a line, numbered from left to right from 1 to n.
Each computer containsexactly one piece of information, each of which Doc wants to get eventually. The computers are equipped with a security system, so to crack the i-th
of them, the robot needs to collect at least ai any
pieces of information from the other computers. Doc can hack the computer only if he is right next to it.
The robot is assembled using modern technologies and can move along the line of computers in either of the two possible directions, but the change of direction requires a large amount
of resources from Doc. Tell the minimum number of changes of direction, which the robot will have to make to collect all n parts
of information if initially it is next to computer with number 1.
It is guaranteed that there exists at least one sequence of the robot's actions, which leads to the collection
of all information. Initially Doc doesn't have any pieces of information.

Input
The first line contains number n (1 ≤ n ≤ 1000).
The second line contains n non-negative integers a1, a2, ..., an (0 ≤ ai < n),
separated by a space. It is guaranteed that there exists a way for robot to collect all pieces of the information.

Output
Print a single number — the minimum number of changes in direction that the robot will have to make in order to collect all n parts
of information.

Sample test(s)

input
3
0 2 0


output
1


input
5
4 2 3 0 1


output
3


input
7
0 3 1 0 5 2 6


output
2


Note
In the first sample you can assemble all the pieces of information in the optimal manner by assembling first the piece of information in the first computer, then in the third one,
then change direction and move to the second one, and then, having 2 pieces of information, collect the last piece.
In the second sample to collect all the pieces of information in the optimal manner, Doc can go to the fourth computer and get the piece of information, then go to the fifth computer
with one piece and get another one, then go to the second computer in the same manner, then to the third one and finally, to the first one. Changes of direction will take place before moving from the fifth to the second computer, then from the second to the
third computer, then from the third to the first computer.
In the third sample the optimal order of collecting parts from computers can look like that: 1->3->4->6->2->5->7.

#include<stdio.h>
#include<string.h>
#include<ctype.h>
#include<math.h>
#include<iostream>
#include<string>
#include<set>
#include<map>
#include<vector>
#include<queue>
#include<bitset>
#include<algorithm>
#include<time.h>
using namespace std;
void fre(){freopen("c://test//input.in","r",stdin);freopen("c://test//output.out","w",stdout);}
#define MS(x,y) memset(x,y,sizeof(x))
#define MC(x,y) memcpy(x,y,sizeof(x))
#define MP(x,y) make_pair(x,y)
#define ls o<<1#define rs o<<1|1typedef long long LL;
typedef unsigned long long UL;
typedef unsigned int UI;
template <class T1,class T2>inline void gmax(T1 &a,T2 b){if(b>a)a=b;}
template <class T1,class T2>inline void gmin(T1 &a,T2 b){if(b<a)a=b;}
const int N=1010,M=0,Z=1e9+7,ms63=1061109567;
int casenum,casei;
int n;
int a
;
int main()
{
while(~scanf("%d",&n))
{
for(int i=1;i<=n;i++)scanf("%d",&a[i]);
int sum=0;
for(int tim=0;tim<n;tim++)
{
if(tim%2==0)
{
for(int i=1;i<=n;i++)if(sum>=a[i])
{
++sum;
a[i]=1e9;
}
}
else
{
for(int i=n;i>=1;i--)if(sum>=a[i])
{
++sum;
a[i]=1e9;
}
}
if(sum==n)
{
printf("%d\n",tim);
break;
}
}
}
return 0;
}
/*
【题意】
给你n([1,1000])个数a[],位于一个数轴上,我们每次可以选择向左或向右移动。
a[i]表示我们要打开第i号箱子需要先打开多少个箱子。
一开始我们在起点1,没有打开过箱子,问你至少要转弯多少次,才可以打开完所有的箱子(数据保证一定有解)

【类型】
贪心

【分析】
按照贪心策略,我们每次一定走到头再转弯,能拿的都拿。
最多转弯1000次,所以O(n^2)的暴力即可AC这道题。

*/
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  codeforces 贪心